#####################################################-*- makefile -*-##
# CERT SiLK Analysis Suite Global Makefile
# $SiLK: recurse.mk 3949 2006-06-09 14:36:42Z mthomas $
#######################################################################

# Protect against typos that create empty list of objects and invoke
# infinite recursion
ifeq ($(strip $(WITHDEPS_OBJ)),)
$(error No objects given for target--check for typos in your makefile)
endif


#######################################################################
# Get common variables
#######################################################################

SHELL = /bin/sh

include $(top_builddir)/skconfig.mk
include $(top_srcdir)/target.mk


# Build library list from the list of required libraries
DEPLIBS_FLAGS=$(DEPLIBS_DIRS) $(patsubst lib%.a,-l%,$(notdir $(WITHDEPS_LIB)))

# Add additional flags/libraries from configure and the local makefile
LDFLAGS_COMMON=$(WITHDEP_LDFLAGS) $(LDFLAGS_LOCAL) $(STDLIBS)


#######################################################################
# Compilation
#######################################################################

# Include automatically generated dependency rules
-include $(addsuffix .d, $(basename $(WITHDEPS_OBJ)))

# User application linking rules
$(APPNAMES_LOCAL): $(WITHDEPS_OBJ) $(WITHDEPS_LIB)
	@echo "Final link for application $@"
	$(CC) -o $@ $(LINK_FLAGS) $(WITHDEPS_OBJ) $(DEPLIBS_FLAGS) $(LDFLAGS_COMMON)

# Testing application linking rules
$(TESTAPPS_LOCAL): $(WITHDEPS_OBJ) $(WITHDEPS_LIB)
	@echo "Final link for testing application $@"
	$(CC) -o $@ $(LINK_FLAGS) $(WITHDEPS_OBJ) $(DEPLIBS_FLAGS) $(LDFLAGS_COMMON)

# Library linking rules
$(LIBRARIES_LOCAL): $(WITHDEPS_OBJ)
	@echo "Creating library $@"
	-$(RM) -f $@
	$(AR) cr $@ $^
	$(RANLIB) $@

# Dynamic library rules
$(DYNALIBS_LOCAL): $(WITHDEPS_OBJ) $(WITHDEPS_LIB)
	@echo "Final link for shared object $@"
	$(SHLIB_LD) -o $@ $(SHLIB_LDFLAGS) $(WITHDEPS_OBJ) $(DEPLIBS_FLAGS) $(LDFLAGS_COMMON) $(SHLIB_LIBS)
