#####################################################-*- makefile -*-##
# CERT SiLK Analysis Suite Global Makefile
# $SiLK: target.mk 4964 2006-09-22 15:36:01Z mthomas $
#######################################################################


#######################################################################
# Variables listings possible targets
#######################################################################

# Create variables for targets in the current (local) directory and
# for the top level directory.

APPNAMES_LOCAL = $(APPNAMES)
TESTAPPS_LOCAL = $(TESTAPPS)
LIBRARIES_LOCAL = $(foreach lib,$(LIBRARIES),$(O)lib$(lib).a)
DYNALIBS_LOCAL = $(foreach lib,$(DYNALIBS),$(O)lib$(lib).$(SHLIB_EXT))
SCRIPTS_LOCAL = $(SCRIPTS)
DATA_FILES_LOCAL = $(DATA_FILES)
MAN_PAGES1_LOCAL = $(addprefix $(D),$(filter %.1,$(MAN_PAGES)))
MAN_PAGES3_LOCAL = $(addprefix $(D),$(filter %.3,$(MAN_PAGES)))
MAN_PAGES5_LOCAL = $(addprefix $(D),$(filter %.5,$(MAN_PAGES)))
MAN_PAGES8_LOCAL = $(addprefix $(D),$(filter %.8,$(MAN_PAGES)))

APPNAMES_TOP = $(addprefix $(B),$(APPNAMES_LOCAL))
TESTAPPS_TOP = $(addprefix $(B),$(TESTAPPS_LOCAL))
LIBRARIES_TOP = $(LIBRARIES_LOCAL:$(O)%=$(L)%)
DYNALIBS_TOP = $(DYNALIBS_LOCAL:$(O)%=$(L)%)
SCRIPTS_TOP = $(addprefix $(B),$(SCRIPTS_LOCAL))
DATA_FILES_TOP = $(addprefix $(S),$(DATA_FILES_LOCAL))
MAN_PAGES1_TOP = $(MAN_PAGES1_LOCAL:$(D)%=$(M1)%)
MAN_PAGES3_TOP = $(MAN_PAGES3_LOCAL:$(D)%=$(M3)%)
MAN_PAGES5_TOP = $(MAN_PAGES5_LOCAL:$(D)%=$(M5)%)
MAN_PAGES8_TOP = $(MAN_PAGES8_LOCAL:$(D)%=$(M8)%)


#######################################################################
# Targets
#######################################################################

appnames:: $(APPNAMES_TOP)

testapps:: $(TESTAPPS_TOP)

libraries:: $(LIBRARIES_TOP)

dynalibs:: $(DYNALIBS_TOP)

scripts:: $(SCRIPTS_TOP)

data-files:: $(DATA_FILES_TOP)

man-pages:: $(MAN_PAGES1_TOP) $(MAN_PAGES3_TOP) $(MAN_PAGES5_TOP) $(MAN_PAGES8_TOP)


$(APPNAMES_TOP): $(B)%: %
	$(TEST) -d $(B) || $(MKDIR) -p $(B)
	$(CP) $^ $@.tmp
	-$(RM) -f $@
	$(MV) $@.tmp $@

$(TESTAPPS_TOP): $(B)%: %
	$(TEST) -d $(B) || $(MKDIR) -p $(B)
	$(CP) $^ $@.tmp
	-$(RM) -f $@
	$(MV) $@.tmp $@

$(LIBRARIES_TOP): $(L)%: $(O)%
	$(TEST) -d $(L) || $(MKDIR) -p $(L)
	$(CP) $^ $@.tmp
	-$(RM) -f $@
	$(MV) $@.tmp $@
	$(RANLIB) $@

$(DYNALIBS_TOP): $(L)%: $(O)%
	$(TEST) -d $(L) || $(MKDIR) -p $(L)
	$(CP) $^ $@.tmp
	$(RM) -f $@
	$(MV) $@.tmp $@

$(SCRIPTS_TOP): $(B)%: %
	$(TEST) -d $(B) || $(MKDIR) -p $(B)
	$(CP) $^ $@.tmp
	-$(RM) -f $@
	$(MV) $@.tmp $@

$(DATA_FILES_TOP): $(S)%: %
	$(TEST) -d $(S) || $(MKDIR) -p $(S)
	$(CP) $^ $@.tmp
	-$(RM) -f $@
	$(MV) $@.tmp $@

$(MAN_PAGES1_TOP): $(M1)%: $(D)%
	$(TEST) -d $(M1) || $(MKDIR) -p $(M1)
	$(CP) $^ $@.tmp
	-$(RM) -f $@
	$(MV) $@.tmp $@

$(MAN_PAGES3_TOP): $(M3)%: $(D)%
	$(TEST) -d $(M3) || $(MKDIR) -p $(M3)
	$(CP) $^ $@.tmp
	-$(RM) -f $@
	$(MV) $@.tmp $@

$(MAN_PAGES5_TOP): $(M5)%: $(D)%
	$(TEST) -d $(M5) || $(MKDIR) -p $(M5)
	$(CP) $^ $@.tmp
	-$(RM) -f $@
	$(MV) $@.tmp $@

$(MAN_PAGES8_TOP): $(M8)%: $(D)%
	$(TEST) -d $(M8) || $(MKDIR) -p $(M8)
	$(CP) $^ $@.tmp
	-$(RM) -f $@
	$(MV) $@.tmp $@

install-appnames:: $(APPNAMES_LOCAL) install-only-appnames
install-only-appnames::
	@for i in $(notdir $(APPNAMES_LOCAL)) /dev/null ; do \
	  if $(TEST) -f "$$i" ; then \
	    echo $(INSTALL_PROGRAM) $$i $(bindir)/$$i ; \
	    $(INSTALL_PROGRAM) $$i $(bindir)/$$i ; \
	  fi ; \
	done

install-libraries:: $(LIBRARIES_LOCAL) install-only-libraries
install-only-libraries::
	@for i in /dev/null ; do \
	  if $(TEST) -f "$(O)$$i" ; then \
	    echo $(INSTALL_PROGRAM) $(O)$$i $(libdir)/$$i ; \
	    $(INSTALL_DATA) $(O)$$i $(libdir)/$$i ; \
	    $(RANLIB) $(libdir)/$$i ; \
	  fi ; \
	done

install-dynalibs:: $(DYNALIBS_LOCAL) install-only-dynalibs
install-only-dynalibs::
	@for i in $(notdir $(DYNALIBS_LOCAL)) /dev/null ; do \
	  if $(TEST) -f "$(O)$$i" ; then \
	    echo $(INSTALL_PROGRAM) $(O)$$i $(libdir)/$$i ; \
	    $(INSTALL_PROGRAM) $(O)$$i $(libdir)/$$i ; \
	  fi ; \
	done

install-scripts:: $(SCRIPTS_LOCAL) install-only-scripts
install-only-scripts::
	@for i in $(notdir $(SCRIPTS_LOCAL)) /dev/null ; do \
	  if $(TEST) -f "$$i" ; then \
	    echo $(INSTALL_SCRIPT) $$i $(bindir)/$$i ; \
	    $(INSTALL_SCRIPT) $$i $(bindir)/$$i ; \
	  elif $(TEST) -f "$(srcdir)/$$i" ; then \
	    echo $(INSTALL_SCRIPT) $(srcdir)/$$i $(bindir)/$$i ; \
	    $(INSTALL_SCRIPT) $(srcdir)/$$i $(bindir)/$$i ; \
	  fi ; \
	done

install-data-files:: $(DATA_FILES_LOCAL) install-only-data-files
install-only-data-files::
	@for i in $(notdir $(DATA_FILES_LOCAL)) /dev/null ; do \
	  if $(TEST) -f "$$i" ; then \
	    echo $(INSTALL_DATA) $$i $(datadir)/silk/$$i ; \
	    $(INSTALL_DATA) $$i $(datadir)/silk/$$i ; \
	  elif $(TEST) -f "$(srcdir)/$$i" ; then \
	    echo $(INSTALL_DATA) $(srcdir)/$$i $(datadir)/silk/$$i ; \
	    $(INSTALL_DATA) $(srcdir)/$$i $(datadir)/silk/$$i ; \
	  fi ; \
	done

install-man-pages:: $(MAN_PAGES1_LOCAL) $(MAN_PAGES3_LOCAL) $(MAN_PAGES5_LOCAL) $(MAN_PAGES8_LOCAL) install-only-man-pages
install-only-man-pages::
	@for i in $(notdir $(MAN_PAGES1_LOCAL)) /dev/null ; do \
	  if $(TEST) -f "$(D)$$i" ; then \
	    echo $(INSTALL_DATA) $(D)$$i $(mandir)/man1/$$i ; \
	    $(INSTALL_DATA) $(D)$$i $(mandir)/man1/$$i ; \
	  fi ; \
	done
	@for i in $(notdir $(MAN_PAGES3_LOCAL)) /dev/null ; do \
	  if $(TEST) -f "$(D)$$i" ; then \
	    echo $(INSTALL_DATA) $(D)$$i $(mandir)/man3/$$i ; \
	    $(INSTALL_DATA) $(D)$$i $(mandir)/man3/$$i ; \
	  fi ; \
	done
	@for i in $(notdir $(MAN_PAGES5_LOCAL)) /dev/null ; do \
	  if $(TEST) -f "$(D)$$i" ; then \
	    echo $(INSTALL_DATA) $(D)$$i $(mandir)/man5/$$i ; \
	    $(INSTALL_DATA) $(D)$$i $(mandir)/man5/$$i ; \
	  fi ; \
	done
	@for i in $(notdir $(MAN_PAGES8_LOCAL)) /dev/null ; do \
	  if $(TEST) -f "$(D)$$i" ; then \
	    echo $(INSTALL_DATA) $(D)$$i $(mandir)/man8/$$i ; \
	    $(INSTALL_DATA) $(D)$$i $(mandir)/man8/$$i ; \
	  fi ; \
	done


# Additional rule so "make libXXX.a" does something useful
$(subst $(O),,$(LIBRARIES_LOCAL)): %.a: $(O)%.a
